﻿using System;
using System.IO;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using Interswitchng.CryptoUtil;
using System.Configuration;
using Org.BouncyCastle.Crypto.Parameters;
using Org.BouncyCastle.Math;
using ISW_Autopay_Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        //LblURL.Text = "https://sandbox.interswitchng.com/api/v1/cards/balances";
        LblURL.Text = "https://saturn.interswitchng.com/api/v1/cards/pinchange";
        lblClientId.Text = "IKIAD26CCAC46477A97683D06D0E9E71C45191CEEBA4";
        lblSecret.Text = "BvbTaQk3puInlh3UUUi8WgYvpNGAtUfspLhPMXmw+TU=";
        lblTimestamp.Text = AuthHeader.GetTimeStamp();
        lblNonce.Text = AuthHeader.GetNonce();
        lblHttpMethod.Text = "GET";
        
        lblSignatureMethod.Text = AuthHeader.GetName(SignatureMethod.SHA1);
        lblAuthorization.Text = string.Format("InterswitchAuth {0}", (object)Convert.ToBase64String(Encoding.UTF8.GetBytes(lblClientId.Text)));

        lblSignature.Text = AuthHeader.GetSignature(Http_Method.GET, LblURL.Text, lblTimestamp.Text,lblNonce.Text,lblClientId.Text,lblSecret.Text,SignatureMethod.SHA1);

        lblAuthData.Text = AuthData.GetAuthData("6280511000000095", "0000", "2612");

        var req = (HttpWebRequest)WebRequest.Create(LblURL.Text);
        req.ContentType = "application/json";
        req.Method = lblHttpMethod.Text;
        req.Accept = "application/json";
        req.Headers.Add("Authorization", lblAuthorization.Text);
        req.Headers.Add("timestamp", lblTimestamp.Text);
        req.Headers.Add("nonce", lblNonce.Text);
        req.Headers.Add("signature", lblSignature.Text);
        req.Headers.Add("signaturemethod", lblSignatureMethod.Text);
        req.Headers.Add("auth_data", lblAuthData.Text);
        req.Headers.Add("terminal_id", "3BSU0001");
        req.Headers.Add("product_code", "AUTOPAY");

        var response = (HttpWebResponse)req.GetResponse();
        var hResponseStream = response.GetResponseStream();

        var sReader = new StreamReader(hResponseStream);
        lblResult.Text = sReader.ReadToEnd();

    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        lblUrl1.Text = "https://sandbox.interswitchng.com/api/v1/cards/pinchange";
        lblClientId1.Text = "IKIA89010217044B016FE467FF4B6EF9A1DA31DCDEEB";
        lblSecret1.Text = "+SD6XVQ7D6SOZkSQJ9N3ki5eApIhXcaE6RihioHPj/Y=";
        lblTimestamp1.Text = AuthHeader.GetTimeStamp();
        lblNonce1.Text = AuthHeader.GetNonce();
        lblHttpMethod1.Text = "PUT";
        lblTerminalId.Text = "3SMX0001";

        lblSignatureMethod1.Text = AuthHeader.GetName(SignatureMethod.SHA1);
        lblAuthorization1.Text = string.Format("InterswitchAuth {0}", (object)Convert.ToBase64String(Encoding.UTF8.GetBytes(lblClientId1.Text)));

        lblSignature1.Text = AuthHeader.GetSignature(Http_Method.PUT, lblUrl1.Text, lblTimestamp1.Text, lblNonce1.Text, lblClientId1.Text, lblSecret1.Text, SignatureMethod.SHA1);

        lblOldAuthData.Text = AuthData.GetAuthData("6280511000000095", "1234", "2612");//YY/MM
        lblNewAuthData.Text = AuthData.GetAuthData("6280511000000095", "0000", "2612");

        var req = (HttpWebRequest)WebRequest.Create(lblUrl1.Text);
        req.ContentType = "application/json";
        req.Method = lblHttpMethod1.Text;
        req.Accept = "application/json";
        
        var sWriter = new StreamWriter(req.GetRequestStream());

        var body = new StringBuilder();
        body.AppendFormat("{{\"oldAuthData\":\"{0}\",", lblOldAuthData.Text);
        body.AppendFormat("\"newAuthData\":\"{0}\",", lblNewAuthData.Text);
        body.AppendFormat("\"terminalId\":\"{0}\",", lblTerminalId.Text);
        body.AppendFormat("\"productCode\": \"{0}\"}}", "AUTOPAY");
        lblBody.Text = body.ToString();
        sWriter.Write(body);
        sWriter.Close();

        req.Headers.Add("Authorization", lblAuthorization1.Text);
        req.Headers.Add("timestamp", lblTimestamp1.Text);
        req.Headers.Add("nonce", lblNonce1.Text);
        req.Headers.Add("signature", lblSignature1.Text);
        req.Headers.Add("signaturemethod", lblSignatureMethod1.Text);

        var response = (HttpWebResponse)req.GetResponse();
        var hResponseStream = response.GetResponseStream();

        var sReader = new StreamReader(hResponseStream);
        lblResult1.Text = sReader.ReadToEnd();
    }
}